/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */

import {
  Context,
  Pda,
  PublicKey,
  Signer,
  TransactionBuilder,
  transactionBuilder,
} from '@metaplex-foundation/umi';
import {
  Serializer,
  array,
  mapSerializer,
  struct,
  u8,
} from '@metaplex-foundation/umi/serializers';
import {
  ResolvedAccount,
  ResolvedAccountsWithIndices,
  getAccountMetasAndSigners,
} from '../shared';

// Accounts.
export type SetCollectionInstructionAccounts = {
  candyMachine: PublicKey | Pda;
  authority?: Signer;
  authorityPda: PublicKey | Pda;
  payer?: Signer;
  collectionMint: PublicKey | Pda;
  collectionMetadata: PublicKey | Pda;
  collectionAuthorityRecord: PublicKey | Pda;
  newCollectionUpdateAuthority: Signer;
  newCollectionMetadata: PublicKey | Pda;
  newCollectionMint: PublicKey | Pda;
  newCollectionMasterEdition: PublicKey | Pda;
  newCollectionAuthorityRecord: PublicKey | Pda;
  tokenMetadataProgram?: PublicKey | Pda;
  systemProgram?: PublicKey | Pda;
};

// Data.
export type SetCollectionInstructionData = { discriminator: Array<number> };

export type SetCollectionInstructionDataArgs = {};

export function getSetCollectionInstructionDataSerializer(): Serializer<
  SetCollectionInstructionDataArgs,
  SetCollectionInstructionData
> {
  return mapSerializer<
    SetCollectionInstructionDataArgs,
    any,
    SetCollectionInstructionData
  >(
    struct<SetCollectionInstructionData>(
      [['discriminator', array(u8(), { size: 8 })]],
      { description: 'SetCollectionInstructionData' }
    ),
    (value) => ({
      ...value,
      discriminator: [192, 254, 206, 76, 168, 182, 59, 223],
    })
  ) as Serializer<
    SetCollectionInstructionDataArgs,
    SetCollectionInstructionData
  >;
}

// Instruction.
export function setCollection(
  context: Pick<Context, 'identity' | 'payer' | 'programs'>,
  input: SetCollectionInstructionAccounts
): TransactionBuilder {
  // Program ID.
  const programId = context.programs.getPublicKey(
    'mplCandyMachineCore',
    'CndyV3LdqHUfDLmE5naZjVN8rBZz4tqhdefbAnjHG3JR'
  );

  // Accounts.
  const resolvedAccounts: ResolvedAccountsWithIndices = {
    candyMachine: {
      index: 0,
      isWritable: true,
      value: input.candyMachine ?? null,
    },
    authority: { index: 1, isWritable: false, value: input.authority ?? null },
    authorityPda: {
      index: 2,
      isWritable: true,
      value: input.authorityPda ?? null,
    },
    payer: { index: 3, isWritable: false, value: input.payer ?? null },
    collectionMint: {
      index: 4,
      isWritable: false,
      value: input.collectionMint ?? null,
    },
    collectionMetadata: {
      index: 5,
      isWritable: false,
      value: input.collectionMetadata ?? null,
    },
    collectionAuthorityRecord: {
      index: 6,
      isWritable: true,
      value: input.collectionAuthorityRecord ?? null,
    },
    newCollectionUpdateAuthority: {
      index: 7,
      isWritable: true,
      value: input.newCollectionUpdateAuthority ?? null,
    },
    newCollectionMetadata: {
      index: 8,
      isWritable: false,
      value: input.newCollectionMetadata ?? null,
    },
    newCollectionMint: {
      index: 9,
      isWritable: false,
      value: input.newCollectionMint ?? null,
    },
    newCollectionMasterEdition: {
      index: 10,
      isWritable: false,
      value: input.newCollectionMasterEdition ?? null,
    },
    newCollectionAuthorityRecord: {
      index: 11,
      isWritable: true,
      value: input.newCollectionAuthorityRecord ?? null,
    },
    tokenMetadataProgram: {
      index: 12,
      isWritable: false,
      value: input.tokenMetadataProgram ?? null,
    },
    systemProgram: {
      index: 13,
      isWritable: false,
      value: input.systemProgram ?? null,
    },
  };

  // Default values.
  if (!resolvedAccounts.authority.value) {
    resolvedAccounts.authority.value = context.identity;
  }
  if (!resolvedAccounts.payer.value) {
    resolvedAccounts.payer.value = context.payer;
  }
  if (!resolvedAccounts.tokenMetadataProgram.value) {
    resolvedAccounts.tokenMetadataProgram.value = context.programs.getPublicKey(
      'mplTokenMetadata',
      'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'
    );
    resolvedAccounts.tokenMetadataProgram.isWritable = false;
  }
  if (!resolvedAccounts.systemProgram.value) {
    resolvedAccounts.systemProgram.value = context.programs.getPublicKey(
      'splSystem',
      '11111111111111111111111111111111'
    );
    resolvedAccounts.systemProgram.isWritable = false;
  }

  // Accounts in order.
  const orderedAccounts: ResolvedAccount[] = Object.values(
    resolvedAccounts
  ).sort((a, b) => a.index - b.index);

  // Keys and Signers.
  const [keys, signers] = getAccountMetasAndSigners(
    orderedAccounts,
    'programId',
    programId
  );

  // Data.
  const data = getSetCollectionInstructionDataSerializer().serialize({});

  // Bytes Created On Chain.
  const bytesCreatedOnChain = 0;

  return transactionBuilder([
    { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
  ]);
}
